searchData={"items":[{"type":"module","title":"SmartToken","doc":"","ref":"SmartToken.html"},{"type":"function","title":"SmartToken.access_count/1","doc":"","ref":"SmartToken.html#access_count/1"},{"type":"function","title":"SmartToken.account_verification_token/1","doc":"Create a new account verification token.","ref":"SmartToken.html#account_verification_token/1"},{"type":"function","title":"SmartToken.authorize!/4","doc":"","ref":"SmartToken.html#authorize!/4"},{"type":"function","title":"SmartToken.bind/3","doc":"","ref":"SmartToken.html#bind/3"},{"type":"function","title":"SmartToken.bind!/4","doc":"","ref":"SmartToken.html#bind!/4"},{"type":"function","title":"SmartToken.bind_ref/2","doc":"","ref":"SmartToken.html#bind_ref/2"},{"type":"function","title":"SmartToken.encoded_key/1","doc":"","ref":"SmartToken.html#encoded_key/1"},{"type":"function","title":"SmartToken.ip_whitelist/2","doc":"Add ip whitelist entry(ies)","ref":"SmartToken.html#ip_whitelist/2"},{"type":"function","title":"SmartToken.multi_use/2","doc":"","ref":"SmartToken.html#multi_use/2"},{"type":"function","title":"SmartToken.new/1","doc":"Create a new token with the given settings.","ref":"SmartToken.html#new/1"},{"type":"function","title":"SmartToken.record_access!/3","doc":"","ref":"SmartToken.html#record_access!/3"},{"type":"function","title":"SmartToken.record_invalid_access!/3","doc":"","ref":"SmartToken.html#record_invalid_access!/3"},{"type":"function","title":"SmartToken.record_invalid_access!/4","doc":"","ref":"SmartToken.html#record_invalid_access!/4"},{"type":"function","title":"SmartToken.record_valid_access!/3","doc":"","ref":"SmartToken.html#record_valid_access!/3"},{"type":"function","title":"SmartToken.session_value/3","doc":"Add session key,value constraint","ref":"SmartToken.html#session_value/3"},{"type":"function","title":"SmartToken.single_use/1","doc":"","ref":"SmartToken.html#single_use/1"},{"type":"function","title":"SmartToken.unlimited_use/1","doc":"","ref":"SmartToken.html#unlimited_use/1"},{"type":"function","title":"SmartToken.validate/4","doc":"","ref":"SmartToken.html#validate/4"},{"type":"function","title":"SmartToken.validate_access_count/1","doc":"","ref":"SmartToken.html#validate_access_count/1"},{"type":"function","title":"SmartToken.validate_period/2","doc":"","ref":"SmartToken.html#validate_period/2"},{"type":"function","title":"SmartToken.validate_remote_ip/2","doc":"","ref":"SmartToken.html#validate_remote_ip/2"},{"type":"function","title":"SmartToken.validate_session_values/2","doc":"","ref":"SmartToken.html#validate_session_values/2"},{"type":"function","title":"SmartToken.validity_period/3","doc":"Add a validity period to the token\n    - from_period: `:unbound | {:relative, [{period, count}]} | {:fixed, time}`\n    - to_period: `:unbound | {:relative, [{period, count}]} | {:fixed, time}`","ref":"SmartToken.html#validity_period/3"},{"type":"type","title":"SmartToken.t/0","doc":"","ref":"SmartToken.html#t:t/0"},{"type":"module","title":"SmartToken.Ecto.SerializedTerm","doc":"","ref":"SmartToken.Ecto.SerializedTerm.html"},{"type":"function","title":"SmartToken.Ecto.SerializedTerm.cast/1","doc":"","ref":"SmartToken.Ecto.SerializedTerm.html#cast/1"},{"type":"function","title":"SmartToken.Ecto.SerializedTerm.cast!/1","doc":"Same as `cast/1` but raises `Ecto.CastError` on invalid arguments.","ref":"SmartToken.Ecto.SerializedTerm.html#cast!/1"},{"type":"function","title":"SmartToken.Ecto.SerializedTerm.dump/1","doc":"","ref":"SmartToken.Ecto.SerializedTerm.html#dump/1"},{"type":"function","title":"SmartToken.Ecto.SerializedTerm.equal?/2","doc":"","ref":"SmartToken.Ecto.SerializedTerm.html#equal?/2"},{"type":"function","title":"SmartToken.Ecto.SerializedTerm.load/1","doc":"","ref":"SmartToken.Ecto.SerializedTerm.html#load/1"},{"type":"function","title":"SmartToken.Ecto.SerializedTerm.load!/1","doc":"","ref":"SmartToken.Ecto.SerializedTerm.html#load!/1"},{"type":"module","title":"SmartToken.Migration","doc":"","ref":"SmartToken.Migration.html"},{"type":"function","title":"SmartToken.Migration.down/1","doc":"","ref":"SmartToken.Migration.html#down/1"},{"type":"function","title":"SmartToken.Migration.up/1","doc":"","ref":"SmartToken.Migration.html#up/1"},{"type":"module","title":"SmartToken.Schema.SmartToken","doc":"","ref":"SmartToken.Schema.SmartToken.html"},{"type":"function","title":"SmartToken.Schema.SmartToken.get_smart_token/3","doc":"","ref":"SmartToken.Schema.SmartToken.html#get_smart_token/3"},{"type":"function","title":"SmartToken.Schema.SmartToken.lookup_smart_token/4","doc":"","ref":"SmartToken.Schema.SmartToken.html#lookup_smart_token/4"},{"type":"function","title":"SmartToken.Schema.SmartToken.save_smart_token/3","doc":"","ref":"SmartToken.Schema.SmartToken.html#save_smart_token/3"},{"type":"behaviour","title":"SmartToken.SchemaBehaviour","doc":"","ref":"SmartToken.SchemaBehaviour.html"},{"type":"callback","title":"SmartToken.SchemaBehaviour.lookup_smart_token/4","doc":"","ref":"SmartToken.SchemaBehaviour.html#c:lookup_smart_token/4"},{"type":"callback","title":"SmartToken.SchemaBehaviour.save_smart_token/3","doc":"","ref":"SmartToken.SchemaBehaviour.html#c:save_smart_token/3"},{"type":"exception","title":"SmartToken.Exception","doc":"","ref":"SmartToken.Exception.html"},{"type":"extras","title":"SmartToken","doc":"# SmartToken\nSmart Tokens provide a mechanism to associate a query token with a given set of permissions and access attempts.\nIt may be used, for example, for a single login link, or to allow 5 downloads of a specific file.\n\n- Time Limited Tokens\n- Use Limited Tokens\n- Permission Grant\n- Context (limit permission grant to specific entities)\n- Tamper Protection\n\n# Setup","ref":"readme.html"},{"type":"extras","title":"1. Add SmartToken to your mix.exs file. - SmartToken","doc":"```elixir\ndef deps do\n  [\n    {:smart_token, \"~> 0.1.1\"}\n  ]\nend\n```","ref":"readme.html#1-add-smarttoken-to-your-mix-exs-file"},{"type":"extras","title":"2. Set config.exs repo or schema for smart token. - SmartToken","doc":"#### Repo - you ecto repo where the SmartToken table will be stored\n```elixir\nconfig :smart_token, repo: MyApp.Repo\n```\n#### Schema - you ecto schema where the SmartToken table will be stored\nSchema module must implement the SmartToken.Schema behaviour. Note get_token, lookup_token should insure the nested smart_token element's identifier field is set to the id of the record if\nnot set on create.\n\nSee `SSmartToken.Schema.SmartToken` for an example implementation.\n\n```elixir\nconfig :smart_token, schema: MyApp.Schema.SmartToken\n```","ref":"readme.html#2-set-config-exs-repo-or-schema-for-smart-token"},{"type":"extras","title":"3. Setup migration - SmartToken","doc":"","ref":"readme.html#3-setup-migration"},{"type":"extras","title":"Run - SmartToken","doc":"``` \nmix ecto.gen.migration setup_smart_tokens \n```","ref":"readme.html#run"},{"type":"extras","title":"Edit migration file: - SmartToken","doc":"```\ndefmodule MyApp.Repo.Migrations.SetupSmartTokens do\n  use Ecto.Migration\n\n  def up() do \n    SmartTokens.Migration.up(1)\n  end\n\n  def down() do \n    SmartTokens.Migration.down(1)\n  end\nend\n```","ref":"readme.html#edit-migration-file"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}